#ifndef __RECTANGLE3_H
#define __RECTANGLE3_H

#include "Vector3.h"

/// rectangle vertices
//   3 2
//   0 1
class Rectangle3 {
public:
  Vector3 mVertices[4];

  Rectangle3() {}
  
  Rectangle3(const Vector3 &v0,
	     const Vector3 &v1,
	     const Vector3 &v2,
	     const Vector3 &v3) {
    mVertices[0] = v0;
    mVertices[1] = v1;
    mVertices[2] = v2;
    mVertices[3] = v3;
  }
  
  Vector3 GetNormal() {
    return Normalize(CrossProd(mVertices[0]-mVertices[1],
			       mVertices[2]-mVertices[1]
			       ));
  }
  
  Vector3 GetCenter() {
    return (mVertices[0] + mVertices[1] + mVertices[2] + mVertices[3])/4.0f;
  }


  void
  Split(const int axis,
	Rectangle3 &r1,
	Rectangle3 &r2
	) const;
  
};


#endif
